SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Magnitude subclass: #Measure
	instanceVariableNames: 'unit amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'initialization' stamp: 'achavez 5/8/2013 20:22'!
amount: aNumber unit: aUnit

	^self new amount: aNumber unit: aUnit! !

!Measure methodsFor: 'services' stamp: 'MatiasSalegas 5/24/2013 14:09'!
* aMeasure 

	(aMeasure isKindOf: Measure)
		ifTrue: 
			[ ^Measure
				amount: (self convertTo: self unit baseUnit) amount * (aMeasure convertTo: aMeasure unit baseUnit) amount
				unit: (self convertTo: self unit baseUnit) unit * (aMeasure convertTo: aMeasure unit baseUnit) unit ].
	(aMeasure isKindOf: Measure) 
		ifFalse: 
			[ ^Measure amount: amount * aMeasure unit: unit ]! !

!Measure methodsFor: 'services' stamp: 'msalegas 5/23/2013 18:13'!
+ aDistance 
	|converted|
	self unit baseUnit = aDistance unit baseUnit ifFalse: [ ^self error ].
	converted := aDistance convertTo: unit.
	^Measure amount: amount + converted amount unit: unit! !

!Measure methodsFor: 'services' stamp: 'achavez 5/13/2013 21:32'!
-aDistance 
	^self  + aDistance negated! !

!Measure methodsFor: 'services' stamp: 'achavez 5/13/2013 21:34'!
/ aNumber
	^self * (1/ aNumber)! !

!Measure methodsFor: 'comparing' stamp: 'achavez 5/15/2013 21:36'!
< aDistance 
	|converted| 
	converted := aDistance convertTo: unit.
	^amount < converted amount.! !

!Measure methodsFor: 'comparing' stamp: 'achavez 5/22/2013 21:17'!
= aDistance
	aDistance class = self class ifFalse: [ ^false ].
	aDistance unit baseUnit = unit baseUnit ifFalse: [ ^false ].
	^(aDistance convertTo: unit) amount =  amount.
! !

!Measure methodsFor: 'accessing' stamp: 'achavez 5/8/2013 20:24'!
amount
	^amount! !

!Measure methodsFor: 'initialization' stamp: 'achavez 5/8/2013 20:23'!
amount: aNumber unit: aUnit
	amount := aNumber.
	unit := aUnit! !

!Measure methodsFor: 'accessing' stamp: 'msalegas 5/23/2013 18:03'!
canNotConvertMeasurementException
	
	self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'! !

!Measure methodsFor: 'as yet unclassified' stamp: 'msalegas 5/23/2013 18:04'!
convertTo: aUnit 
	|value|
	self unit baseUnit = aUnit baseUnit ifFalse: [ ^self ].
	value := unit convert: amount to: aUnit.
	^ Measure amount: value unit: aUnit! !

!Measure methodsFor: 'comparing' stamp: 'achavez 5/20/2013 21:47'!
hash 
	|converted|
	converted := self convertTo: unit baseUnit.
	^converted amount hash bitXor: converted unit hash! !

!Measure methodsFor: 'services' stamp: 'achavez 5/20/2013 20:39'!
negated
	^Measure amount: amount negated unit: unit.! !

!Measure methodsFor: 'printing' stamp: 'achavez 5/8/2013 20:24'!
printOn: aStream 

	aStream nextPutAll: amount asString, ' '.
	unit printOn: aStream.
	amount > 1 ifTrue: [ aStream nextPut: $s ]! !

!Measure methodsFor: 'creation' stamp: 'achavez 5/20/2013 20:39'!
to: stop 
	|step|
	step := Measure amount: 1 unit: unit.
	^self to: stop by: step.! !

!Measure methodsFor: 'creation' stamp: 'achavez 5/13/2013 20:37'!
to: stop by: step 
	
	^DistanceInterval from: self to: stop by: step.! !

!Measure methodsFor: 'accessing' stamp: 'achavez 5/8/2013 20:25'!
unit
	^unit! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'HernanWilkinson 4/25/2011 17:22'!
canNotConvertMeasurementException
	
	self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'achavez 5/22/2013 19:07'!
celsius
	
	^NonProportionalDerivedUnit celsius! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
centimeter
	
	^ProportionalDerivedUnit centimeter! !

!MeasureTest methodsFor: 'as yet unclassified' stamp: 'msalegas 5/23/2013 18:49'!
cubicMeter

	^(self meter * self meter) * self meter! !

!MeasureTest methodsFor: 'time units' stamp: 'msalegas 5/23/2013 17:43'!
day
	
	^ProportionalDerivedUnit day! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
decameter
	
	^ProportionalDerivedUnit decameter! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
decimeter
	
	^ProportionalDerivedUnit decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/20/2013 20:35'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/20/2013 20:36'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:48'!
eightCubicMeters

	^Measure amount: 8 unit: self cubicMeter! !

!MeasureTest methodsFor: 'temperature units' stamp: 'achavez 5/22/2013 19:07'!
fahrenheit
	
	^NonProportionalDerivedUnit fahrenheit! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:40'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:50'!
fourSquaredMeters

	^Measure amount: 4 unit: self squaredMeter! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
hectometer
	
	^ProportionalDerivedUnit hectometer! !

!MeasureTest methodsFor: 'time units' stamp: 'msalegas 5/23/2013 17:43'!
hour
	
	^ProportionalDerivedUnit hour! !

!MeasureTest methodsFor: 'temperature units' stamp: 'achavez 5/22/2013 20:11'!
kelvin
	
	^BaseUnit kelvin! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
kilometer
	
	^ProportionalDerivedUnit kilometer! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 20:10'!
meter

	^BaseUnit meter! !

!MeasureTest methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 15:39'!
meterTimesSecond
	^self meter * self second! !

!MeasureTest methodsFor: 'distance units' stamp: 'achavez 5/22/2013 19:06'!
millimeter
	
	^ProportionalDerivedUnit millimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
minusOneMeter 

	^Measure amount: 1 negated unit: self meter! !

!MeasureTest methodsFor: 'time units' stamp: 'achavez 5/22/2013 20:16'!
minute
	
	^ProportionalDerivedUnit minute! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achavez 5/22/2013 20:11'!
oneCelsius
	
	^Measure amount: 1 unit: self celsius! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
oneCentimeter
	
	^Measure amount: 1 unit: self centimeter! !

!MeasureTest methodsFor: 'time measures' stamp: 'msalegas 5/23/2013 17:41'!
oneDay
	
	^Measure amount: 1 unit: self day! !

!MeasureTest methodsFor: 'time measures' stamp: 'msalegas 5/23/2013 17:41'!
oneHour
	
	^Measure amount: 1 unit: self hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
oneHundredCentimeters

	^Measure amount: 100 unit: self centimeter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:51'!
oneHundredTwentyOneMetersPerSecond

	^Measure amount: 121 unit: self meterPerSecond! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
oneMeter
	
	^Measure amount: 1 unit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:51'!
oneMeterPerSecond

	^Measure amount: 1 unit: self meterPerSecond! !

!MeasureTest methodsFor: 'time measures' stamp: 'achavez 5/22/2013 20:13'!
oneMinute
	
	^Measure amount: 1 unit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'achavez 5/22/2013 20:13'!
oneSecond

	^Measure amount: 1 unit: self second! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:52'!
oneSquaredMeter

	^Measure amount: 1 unit: self squaredMeter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:52'!
oneSquaredSecond

	^Measure amount: 1 unit: self squaredSecond! !

!MeasureTest methodsFor: 'time units' stamp: 'achavez 5/22/2013 20:16'!
second
	
	^BaseUnit second! !

!MeasureTest methodsFor: 'as yet unclassified' stamp: 'achavez 5/20/2013 20:43'!
seconds
	self shouldBeImplemented.! !

!MeasureTest methodsFor: 'time measures' stamp: 'msalegas 5/23/2013 17:41'!
sixtyMinutes
	
	^Measure amount: 60 unit: self minute! !

!MeasureTest methodsFor: 'time measures' stamp: 'msalegas 5/23/2013 17:41'!
sixtyOneSeconds
	
	^Measure amount: 61 unit: self second! !

!MeasureTest methodsFor: 'time measures' stamp: 'achavez 5/22/2013 20:12'!
sixtySeconds
	
	^Measure amount: 60 unit: self second! !

!MeasureTest methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 13:59'!
squaredMeter

	^self meter * self meter! !

!MeasureTest methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 14:00'!
squaredSecond

	^self second * self second! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'achavez 5/22/2013 20:42'!
test01ObjectsRepresentingSameMeasureShouldBeEqual
	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'Anonymous 5/23/2013 17:38'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:13'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celcius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'msalegas 5/23/2013 18:08'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achavez 5/22/2013 20:11'!
thirtyTwoFahrenheits
	
	^Measure amount: 32 unit: self fahrenheit ! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'msalegas 5/23/2013 17:42'!
twentyFourHours
	
	^Measure amount: 24 unit: self hour! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'msalegas 5/23/2013 17:40'!
twoCelsius
	
	^Measure amount: 2 unit: self celsius! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
twoHundredCentimeters
	
	^Measure amount: 200 unit: self centimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
twoMeters
	
	^Measure amount: 2 unit: self meter! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:53'!
twoMetersBySecond

	^Measure amount: 2 unit: self meterBySecond! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:53'!
twoMetersPerSquaredSecond

	^Measure amount: 2 unit: self meterPerSquaredSecond! !

!MeasureTest methodsFor: 'compound measures' stamp: 'msalegas 5/23/2013 18:54'!
twoMetersTimesSecond

	^Measure amount: 2 unit: self meterTimesSecond! !

!MeasureTest methodsFor: 'time measures' stamp: 'msalegas 5/23/2013 17:42'!
twoSeconds
	
	^Measure amount: 2 unit: self second! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'achavez 5/22/2013 20:11'!
zeroCelsius
	
	^Measure amount: 0 unit: self celsius! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'msalegas 5/23/2013 17:40'!
zeroKelvin
	
	^Measure amount: 0 unit: self kelvin! !

!MeasureTest methodsFor: 'distance measures' stamp: 'achavez 5/22/2013 20:09'!
zeroMeters

	^Measure amount: 0 unit: self meter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'msalegas 5/23/2013 17:42'!
zeroSeconds
	
	^Measure amount: 0 unit: self second! !

Object subclass: #Unit
	instanceVariableNames: 'name baseUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #BaseUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!BaseUnit class methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 19:39'!
kelvin
	^self new name: 'kelvin'! !

!BaseUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 19:08'!
meter 
	^self new name: 'meter'! !

!BaseUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 19:40'!
second 
	^self new name: 'second'! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 21:15'!
= aUnit
	^self class = aUnit class and: [ name = aUnit name ]! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 20:34'!
convertFromBaseUnit: aNumber
	^aNumber! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 20:34'!
convertToBaseUnit: aNumber
	^aNumber! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 21:16'!
hash 	
	^self class hash bitXor: name hash! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 19:59'!
name: aString
	name := aString.
	baseUnit := self.
! !

Unit subclass: #MultipliedUnit
	instanceVariableNames: 'factors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MultipliedUnit class methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 14:20'!
withFactors: aDictionary 

	^self new withFactors: aDictionary ! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 15:14'!
* aUnit 

	| auxiliarDictionary val val2 |
	
	( aUnit isKindOf: MultipliedUnit ) 
		ifTrue: [ 
			auxiliarDictionary := factors.
			aUnit factors
				associationsDo: [ :each |
					val := each value.
					auxiliarDictionary 
						at: each key
						ifPresent: [ val2 := auxiliarDictionary at: each key.
							auxiliarDictionary at: each key put: val + val2 ] ] . 
			^MultipliedUnit new withFactors: auxiliarDictionary ].
	( aUnit isKindOf: MultipliedUnit ) 
		ifFalse:[ 
			auxiliarDictionary := Dictionary new.
			auxiliarDictionary at: (aUnit baseUnit) put: 1.
			^self * (MultipliedUnit new withFactors: auxiliarDictionary )].
		(Dictionary new) at: 1 put: 1! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 15:17'!
= aUnit
	
	^( aUnit isKindOf: MultipliedUnit ) and: [ factors = aUnit factors ]! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 15:27'!
baseUnit 

	^self! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 15:21'!
convertFromBaseUnit: aNumber
	^aNumber! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 15:21'!
convertToBaseUnit: aNumber
	^aNumber! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 14:15'!
factors

	^factors! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'MatiasSalegas 5/24/2013 14:37'!
withFactors: aDictionary

	factors := aDictionary ! !

Unit subclass: #NonProportionalDerivedUnit
	instanceVariableNames: 'fromBlock toBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NonProportionalDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 21:40'!
celsius
	^self new name: 'celsius' baseUnit: BaseUnit kelvin fromBaseUnit: [ :n | n - (27315/100) ] toBaseUnit: [ :n | n + (27315/100) ]! !

!NonProportionalDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 21:49'!
fahrenheit
	^self new name: 'fahrenheit' baseUnit: BaseUnit kelvin fromBaseUnit: [ :n | (9/5) * n - (45967/100)] toBaseUnit: [ :n | n + (45967/100) * (5/9) ]! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'msalegas 5/23/2013 17:47'!
= aUnit
	^super = aUnit and: [ fromBlock = aUnit fromBlock and: [ toBlock = aUnit toBlock ] ]! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 20:04'!
convertFromBaseUnit: aNumber
	^fromBlock value: aNumber! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 20:04'!
convertToBaseUnit: aNumber
	^toBlock value: aNumber! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 20:02'!
fromBlock
	^fromBlock! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 20:03'!
hash 
	^(super hash bitXor: fromBlock hash) bitXor: toBlock hash! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 19:57'!
name: aName baseUnit: aUnit fromBaseUnit: aBlock toBaseUnit: anotherBlock
	name := aName.
	baseUnit := aUnit.
	fromBlock := aBlock.
	toBlock := anotherBlock! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 19:14'!
name: aName formula: aBlock
	name := aName.
	formula := aBlock! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'achavez 5/22/2013 20:02'!
toBlock
	^toBlock! !

Unit subclass: #ProportionalDerivedUnit
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
centimeter
	^self new name: 'centimeter' baseUnit: BaseUnit meter factor: 1/100! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'msalegas 5/23/2013 17:45'!
day
	^self new name: 'day' baseUnit: BaseUnit second factor: 24*3600! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
decameter
	^self new name: 'decameter' baseUnit: BaseUnit meter factor: 10! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
decimeter
	^self new name: 'decimeter' baseUnit: BaseUnit meter factor: 1/10! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
hectometer
	^self new name: 'hectometer' baseUnit: BaseUnit meter factor: 100! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'msalegas 5/23/2013 17:44'!
hour
	^self new name: 'hour' baseUnit: BaseUnit second factor: 3600! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:44'!
kilometer
	^self new name: 'kilometer' baseUnit: BaseUnit meter factor: 1000! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:45'!
millimeter
	^self new name: 'millimeter' baseUnit: BaseUnit meter factor: 1/1000! !

!ProportionalDerivedUnit class methodsFor: 'instance creation' stamp: 'achavez 5/22/2013 20:48'!
minute
	^self new name: 'minute' baseUnit: BaseUnit second factor: 60! !

!ProportionalDerivedUnit methodsFor: 'comparing' stamp: 'achavez 5/22/2013 19:19'!
= aUnit
	^super = aUnit and: [factor = aUnit factor]! !

!ProportionalDerivedUnit methodsFor: 'comparing' stamp: 'achavez 5/22/2013 20:06'!
convertFromBaseUnit: aNumber
	^aNumber / factor! !

!ProportionalDerivedUnit methodsFor: 'comparing' stamp: 'achavez 5/22/2013 20:05'!
convertToBaseUnit: aNumber
	^aNumber * factor! !

!ProportionalDerivedUnit methodsFor: 'accessing' stamp: 'achavez 5/22/2013 19:11'!
factor
	^factor! !

!ProportionalDerivedUnit methodsFor: 'comparing' stamp: 'achavez 5/22/2013 19:12'!
hash 
	^super hash bitXor: factor hash! !

!ProportionalDerivedUnit methodsFor: 'initialize-release' stamp: 'achavez 5/22/2013 19:54'!
name: aString baseUnit: aUnit factor: aNumber
	name := aString.
	baseUnit := aUnit.
	factor := aNumber
	! !

!Unit class methodsFor: 'instance creation' stamp: 'achavez 5/13/2013 19:53'!
centimeter
	^self new name: 'centimeter' factor: 100! !

!Unit class methodsFor: 'instance creation' stamp: 'achavez 5/13/2013 19:54'!
decameter
	^self new name: 'decameter' factor: 1/10! !

!Unit class methodsFor: 'instance creation' stamp: 'achavez 5/13/2013 19:54'!
decimeter
	^self new name: 'decimeter' factor: 10! !

!Unit class methodsFor: 'instance creation' stamp: 'achavez 5/13/2013 19:55'!
hectometer
	^self new name: 'hectometer' factor: 1/100! !

!Unit class methodsFor: 'instance creation' stamp: 'achavez 5/13/2013 19:55'!
kilometer
	^self new name: 'kilometer' factor: 1/1000! !

!Unit class methodsFor: 'instance creation' stamp: 'achavez 5/13/2013 19:54'!
meter 
	^self new name: 'meter' factor: 1! !

!Unit class methodsFor: 'instance creation' stamp: 'achavez 5/13/2013 19:56'!
millimeter
	^self new name: 'millimeter' factor: 1000! !

!Unit methodsFor: 'printing' stamp: 'MatiasSalegas 5/24/2013 14:35'!
* aUnit 

	| auxiliarUnit auxiliarDictionary |
	auxiliarDictionary := Dictionary new.
	auxiliarDictionary at: self put: 1.
	auxiliarUnit := MultipliedUnit new.
	auxiliarUnit withFactors: auxiliarDictionary.
	^auxiliarUnit * aUnit ! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 21:15'!
= aUnit 
	^baseUnit = aUnit baseUnit! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 20:00'!
baseUnit
	^baseUnit! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 20:28'!
convert: anAmount fromBaseUnitTo: aUnit
	^aUnit convertFromBaseUnit: anAmount! !

!Unit methodsFor: 'printing' stamp: 'msalegas 5/23/2013 18:01'!
convert: aNumber to: aUnit
	| baseAmount |
	baseAmount := self convertToBaseUnit: aNumber.
	^self convert: baseAmount fromBaseUnitTo: aUnit. ! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 20:05'!
convertFromBaseUnit: aNumber
	^self subclassResponsibility! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 20:05'!
convertToBaseUnit: aNumber
	^self subclassResponsibility! !

!Unit methodsFor: 'accessing' stamp: 'achavez 5/10/2013 20:56'!
factor
	^factor! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 21:16'!
hash
	^baseUnit hash! !

!Unit methodsFor: 'initialize-release' stamp: 'achavez 5/10/2013 20:12'!
name: aString factor: aNumber
	name := aString.
	factor := aNumber
! !

!Unit methodsFor: 'printing' stamp: 'achavez 5/22/2013 19:12'!
printOn: aStream 
	^aStream nextPutAll: name! !
